<CsoundSynthesizer>
<CsOptions>

</CsOptions>
<CsInstruments>

sr=96000
ksmps=10
nchnls=6


gidummy1    	ftgen 1,0,8,-2, 0 ; dummy, to avoide max window error
gidummy2    	ftgen 2,0,8,-2, 0
gidummy3    	ftgen 3,0,8,-2, 0 ; dummy, to avoide max window error
gidummy4    	ftgen 4,0,8,-2, 0

	opcode circumspect,0,iiiiikk

inumbins, iampin, ifreqin, iampoutlist, ipantablist, kmorph_x, kmorph_y xin
 
iclear 		ftgen 0, 0, inumbins, -2, 0	

iampout1	tab_i 0, iampoutlist		;unpack list of ampout tables
iampout2	tab_i 1, iampoutlist
iampout3	tab_i 2, iampoutlist
iampout4	tab_i 3, iampoutlist
iampout5	tab_i 4, iampoutlist
iampout6	tab_i 5, iampoutlist

itab1		tab_i 0, ipantablist		;unpack list of pan tables
itab2		tab_i 1, ipantablist
itab3		tab_i 2, ipantablist
itab4		tab_i 3, ipantablist

	tablecopy iampout1, iclear		;zero ampout tables before processing each frame
	tablecopy iampout2, iclear
	tablecopy iampout3, iclear
	tablecopy iampout4, iclear
	tablecopy iampout5, iclear
	tablecopy iampout6, iclear


itabbuf1 	ftgen 0, 0, inumbins, -2, 0	;buffers for morphing
itabbuf2 	ftgen 0, 0, inumbins, -2, 0

kcount = 0

loop:

kout1	tabmorph kcount, kmorph_x, 0, 1, itab1, itab2
kout2	tabmorph kcount, kmorph_x, 0, 1, itab3, itab4

	tabw   kout1, kcount, itabbuf1
	tabw   kout2, kcount, itabbuf2

kpan	tabmorph kcount, kmorph_y, 0, 1, itabbuf1, itabbuf2



kamp		tab kcount, iampin

		if (kpan<=1) then
			kpan1 = sqrt(1-kpan)
			kpan2 = sqrt(kpan)
			tabw kamp*kpan1 , kcount, iampout1
			tabw kamp*kpan2 , kcount, iampout2
		elseif (kpan<=2) then
			kpan = kpan - 1
			kpan1 = sqrt(1-kpan)
			kpan2 = sqrt(kpan)		
			tabw kamp*kpan1 , kcount, iampout2
			tabw kamp*kpan2 , kcount, iampout4
		elseif (kpan<=3) then
			kpan = kpan - 2
			kpan1 = sqrt(1-kpan)
			kpan2 = sqrt(kpan)	
			tabw kamp*kpan1 , kcount, iampout4
			tabw kamp*kpan2 , kcount, iampout6
		elseif (kpan<=4) then
			kpan = kpan - 3
			kpan1 = sqrt(1-kpan)
			kpan2 = sqrt(kpan)			
			tabw kamp*kpan1 , kcount, iampout6
			tabw kamp*kpan2 , kcount, iampout5
		elseif (kpan<=5) then
			kpan = kpan - 4
			kpan1 = sqrt(1-kpan)
			kpan2 = sqrt(kpan)			
			tabw kamp*kpan1 , kcount, iampout5
			tabw kamp*kpan2 , kcount, iampout3
		elseif (kpan<=6) then
			kpan = kpan - 5
			kpan1 = sqrt(1-kpan)
			kpan2 = sqrt(kpan)			
			tabw kamp*kpan1 , kcount, iampout3
			tabw kamp*kpan2 , kcount, iampout1
		endif		


kcount = kcount + 1

if (kcount < (inumbins-1)) kgoto loop


	endop








	instr 1	;circumspect

	ftfree gidummy1, 0 						; free dummy ftable
	ftfree gidummy2, 0 
	ftfree gidummy3, 0 
	ftfree gidummy4, 0 


kfftsize 	init 4096						;set FFT anal parameters
kol 		init 2
kwindmult 	init 2
kwindtype 	init 1
kphase		init 0

kfftsize	chnget "fftsize"
kol		chnget "ol"
kwindmult	chnget "window"
kwindtype	chnget "windtype"

ktrig           changed     kfftsize,kol, kwindmult, kwindtype 
if ktrig = 1 then
                reinit      pass
endif

pass:
ifftsize =  i(kfftsize)
iol = i(kol)
iNumBins = ifftsize/2 + 1
ihop = ifftsize/iol
iwindow = ifftsize*i(kwindmult)
iwindtype = i(kwindtype)


ain1, ain2, ain3, ain4, ain5, ain6	inh				;get input
	denorm ain1							;denormalise

fin1 pvsanal ain1, ifftsize, ihop, iwindow, iwindtype			;anal

fin2 pvsmix fin1, fin1							;initialise remaining fsigs
fin3 pvsmix fin1, fin1
fin4 pvsmix fin1, fin1
fin5 pvsmix fin1, fin1
fin6 pvsmix fin1, fin1


ifreqin1  ftgen 0,0,iNumBins,-2,0					;define ftables
iampin1	  ftgen 0,0,iNumBins,-2,0
iampout1  ftgen 0,0,iNumBins,-2,0
iampout2  ftgen 0,0,iNumBins,-2,0
iampout3  ftgen 0,0,iNumBins,-2,0
iampout4  ftgen 0,0,iNumBins,-2,0
iampout5  ftgen 0,0,iNumBins,-2,0
iampout6  ftgen 0,0,iNumBins,-2,0
									;pack table into a list

;if p4==1 then revers the stereo image: so that we use to instances of the same instrument to read a stereo input file    
if p4==0 then								
	iampoutlist     ftgen 0,0,8,-2,iampout1, iampout2, iampout3, iampout4, iampout5, iampout6
else
	iampoutlist     ftgen 0,0,8,-2,iampout2, iampout1, iampout4, iampout3, iampout6, iampout5
endif

									;morph parameters  
kmorphmode 	chnget	"morphmode"
kfreq	   	chnget	"freq"
kmorph_y	chnget "morph_y" 
kmorph_x	chnget "morph_x" 
kmorph_y	port	kmorph_y, 0.01, i(kmorph_y) 
kmorph_x	port	kmorph_x, 0.01, i(kmorph_x) 

									;define 4 tables to be morphed
itabpan1    	ftgen 1,0,iNumBins,-7,1, iNumBins,1
itabpan2    	ftgen 2,0,iNumBins,-7,1, iNumBins,1
itabpan3    	ftgen 3,0,iNumBins,-7,1, iNumBins,1
itabpan4    	ftgen 4,0,iNumBins,-7,1, iNumBins,1

ipantablist     ftgen 0,0,4,-2,itabpan1, itabpan2, itabpan3, itabpan4	;pack them into a list


;engin
kflag0 pvsftw fin1, iampin1, ifreqin1
if (kflag0 > 0) then ; only proc when frame is ready

	circumspect	iNumBins, iampin1, ifreqin1,iampoutlist, ipantablist, kmorph_x, kmorph_y

	pvsftr fin1, iampout1, ifreqin1
	pvsftr fin2, iampout2, ifreqin1
	pvsftr fin3, iampout3, ifreqin1
	pvsftr fin4, iampout4, ifreqin1
	pvsftr fin5, iampout5, ifreqin1
	pvsftr fin6, iampout6, ifreqin1
endif


;synthesise output
aout1 pvsynth fin1
aout2 pvsynth fin2
aout3 pvsynth fin3
aout4 pvsynth fin4
aout5 pvsynth fin5
aout6 pvsynth fin6


	outh	aout1, aout2, aout3, aout4, aout5, aout6

	endin




</CsInstruments>

<CsScore>

f0 14400

e

</CsScore>

</CsoundSynthesizer>